// MI - Mass Index

// www.forexdeluxe.com/technical-indicators/mass-index-mi.htm
// en.mimi.hu/stockmarket/mass_index.html
// www.etrading.sk/en/technical-analysis/44-indikatory-technickej-analyzy/110-mass-index


function init()
{
    with (MI) {
         label = "MI";
         createBuffer("MI");
         setBufferColor("MI", "#00FF00");
         setBufferDrawStyle("MI", DrawStyle.LINE);
         setAutoChangeMaxMin("MI");
         addLevel(27, "#FF1F00");
         addLevel(26.5, "#FF1F00");
    }
}

function start()
{
    var Period = 9;
    var num = Shared.numberOfQuotes();
    var MIbuf = new Array(num);
    var MIdelta = new Array(num);

    for (var j = 0; j < num; ++j)  {
        MIdelta[j] = Shared.high(j) - Shared.low(j); 
    }

    var bufMIema = Shared.ema(Period, MIdelta);
    var bufDoppelMiema = Shared.ema(Period, bufMIema);

    for (var j = 0; j < num; ++j)  {
       MIbuf[j] = bufMIema[j]/bufDoppelMiema[j]; 
    }

     MI.setBufferData("MI", summa( MIbuf, 25));
}

function summa(buf, periodsumma) 
{
      result = new Array(buf.length);

// 1 
    result[0] = buf[0];
    for (var i = 1; i < periodsumma; ++i)  
      {
        result[i] = result[i-1] + buf[i];
      }

// 2  
    for (var i = periodsumma; i < buf.length; ++i) 
   {
     result[i] = result[i-1] + buf[i] - buf[i-periodsumma];
   }
return result;
} 






